<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html 
     PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>PythonCAD</title>
  <link href="stylesheets/pythoncad.css" rel="stylesheet" type="text/css" media="screen" />
</head>
<body>
<div id="header">
<div id="main_logo"><img src="images/main_logo.png" alt="PythonCAD" /></div>
<h1>PythonCAD</h1>
</div><!-- header -->
<div id="main_content">
<h2>
Welcome to the PythonCAD home!
</h2>
<p>
PythonCAD is a CAD package written, surprisingly enough, in
<a href="http://www.python.org">Python</a>. The PythonCAD project
aims to produce a scriptable, open-source, easy to use CAD package
for <a href="http://www.kernel.org">Linux</a>, the various flavors
of BSD Unix, commercial Unix, and other platforms to which someone
who is interested ports the program. Work began on PythonCAD in July,
2002, and the first public release was on December 21, 2002.
</p>
<p>
The thirty-sixth release of PythonCAD was made available on May 12, 2007.
This release is primarily a bug-fix release. Several bugs regarding
user preference storage were fixed, as were a number of drawing and entity
selection bugs. PythonCAD users on Windows will now have their preferences
stored in a <q>PythonCAD</q> subdirectory in the <q>APPDATA</q> environment
defined directory.
</p>
<p>
Between the sixteenth and seventeenth releases of the program, the
code was moved around internally to better cooperate with other
Python programs. Unfortunately the Cocoa front-end code has suffered
since then due to lack of maintenance and is currently not functional.
Releases after the seventeenth release have attempted to improve the
situation, but to no avail. A developer or team of developers running
Mac OS X is needed to bring the Cocoa code into a usable state.
</p>
<hr />
<h3>Requirements</h3>
<p>
PythonCAD requires a few bits of software to be up and running on your
machine before it will work. You need to have Python 2.2 or newer
installed with the zlib module, gtk-2.0, and pygtk-2.0. The code uses
features introduced in Python 2.2, so earlier versions will not work, and
the GTK/PyGTK code requirements are equally strict, as code for the
pygtk-2.0 module do not work with the earlier release. If you want
things to work with gtk-1.2 and the older PyGTK, you will have to do
some coding.
</p>
<p>
Users on Mac OS X wishing to try the native Cocoa based front
end will need the Python/Objective-C bridge. Download the
code from <a href="http://pyobjc.sf.net">http://pyobjc.sf.net</a>.
Also, Mac OS X should be at version 10.3, as using older releases
produces erratic results.
</p>
<h3><a href="screenshots.html">Screenshots</a></h3>
<p>
What would a web page for a CAD package be without screenshots?
Go see what PythonCAD <a href="screenshots.html">looks</a> like!
</p>
<h3><a href="download.html">Download the Code</a></h3>
<p>
Archives for the release, as well as information for gaining access to
the code repository is kept on the <a href="download.html">download</a>
page. Go get the code!
</p>
<h3>Building PythonCAD</h3>
<p>
The code for PythonCAD is just Python, so the typical
<q>configure &amp;&amp; make</q> step that many if not most
open source programs require does not apply. At some point in the future,
parts of the code may be written in C, but one of the goals with this
project is to write minimal code in a language other than Python.
Developing with Python, or in a broader sense a higher level language than
C, means quicker development time, fewer lines of code to debug, fewer
platform dependency issues, and a much simpler way to get a program
working. Plus, writing the application in Python means a scripting
language for the application is built in!
</p>
<p>
Thanks go out to the Python developers for all their work in making
Python the powerful, flexible, fast, and easy to use language it
has become. 
</p>
<h3>Installing PythonCAD</h3>
<p>
As mentioned above, you will need to have Python and PyGTK installed
before you can run PythonCAD. Installing these programs is highly
platform specific, so no installation guide for these requirements can
be provided here. You need to follow whatever steps your platform
requires, whether it is installation via a pre-built package or a
download/compile/install routine.
</p>
<p>
The installation of PythonCAD is done in two steps. First, you need to
invoke the <q>setup.py</q> script:
</p>
<pre>
$ python setup.py install
</pre>
<p>
Now, copy the file <q>gtkpycad.py</q> to a directory in which you
can install programs. For example, copy it to /usr/local/bin ...
</p>
<pre>
$ cp gtkpycad.py /usr/local/bin
$ chmod a+x /usr/local/bin/gtkpycad.py
</pre>
<p>
At this point you should be set. Just type <q>gtkpycad.py</q> (without
the quotes) at the prompt and the program should start.
</p>
<p>
The examples above assume that you do not need to be the root user to
do the installation. Whether you do the installation as the administrator
or not depends on your system configuration. There is <strong>no</strong>
reason to make the <q>gtkpycad.py</q> script a setuid script.
</p>
<p>
<strong>Update:</strong> PythonCAD has a means of reading a global
and user preference file. Installing the global preference file will
require root access. To install the file <q>prefs.py</q>, as the
root user do the following ...
</p>
<pre>
# mkdir /etc/pythoncad
# cp prefs.py /etc/pythoncad
</pre>
<p>
The preferences file <q>prefs.py</q> is written in Python. There are
numerous comments in it describing the various items that can be set, and
the file also has examples of adding new linetypes, drawing styles, and
dimension styles to PythonCAD. This file can also be copied into a
<q>.pythoncad</q> directory in a user&apos;s home directory, allowing
an individual user to add additional customization to PythonCAD beyond
those in the global preferences file.
</p>
<h3>Instructions and Documentation</h3>
<p>
So now that PythonCAD is installed, just how does it work?
<a href="usage.html">This</a> page is where to go for some basic
instructions. In the future, as more documentation is created,
it will be located here in addition to being distributed with the code.
</p>
<p>
<strong>Update:</strong> PythonCAD now has a <a href="http://morgul.no-ip.com/dokuwiki">Wiki</a> page! Follow the link for more information! My
thanks to Jose Antonio Martin Prieto for creating and hosting
the Wiki pages.
</p>
<hr />
<h3>Development</h3>
<p>
Unlike many other open-source projects, this one doesn&apos;t use
<a href="http://www.cvshome.org">CVS</a>. Instead, it uses
<a href="http://subversion.tigris.org">Subversion</a> as the source
code management system. Subversion is aiming to replace CVS, fixing
many of the shortcomings currently found in the CVS program.
</p>
<p>
A read-only copy of the main Subversion repository is available. Details
about retrieving the PythonCAD code through Subversion are given on
the <a href="download.html">download</a> page. Mirroring the repository
can possible begin soon, depending on interest from people with the
disk space, tools, and network access needed to act as a mirror site.
</p>
<h4>Mailing List</h4>
<p>
There is a mailing list for people interested in developing and using
PythonCAD. Visit the mailing list <a href="http://mail.python.org/mailman/listinfo/pythoncad">homepage</a> for information about subscribing to the list.
This page also provides a link to the mailing list archives that are
viewable in a web browser.
</p>
<p>Thanks to the good people running the mailing lists hosted at the
<a href="http://www.python.org">Python</a> domain for hosting this list.
</p>
<h4>Program Design</h4>
<p>
The following list provides links to pages that describe in detail various
aspects of PythonCAD that will be of use to developers:
</p>
<ul>
<li><a href="fileformat.html">File Format</a></li>
<li><a href="code_layout.html">Coding Conventions</a></li>
</ul>
<p>
PythonCAD offers an initial implementation of a command interpreter that
allows for the entry of commands within the PythonCAD text entry field
and executes them. This feature will is in an early stage of development,
but is planned to eventually allow for the creation of drawings without
using the mouse and menus. The long term goal is to provide a clean, robust
way for end users to have a command set that is comparable to that found
in other CAD packages and make PythonCAD easier to use. The current list of
commands is available <a href="commands.html">here</a>.
</p>
<hr />
<h3>Design Issues</h3>
<p>
The program is designed to keep the interface code as separate from
the generic code as possible. The goal is to ease the development
of new interfaces for the program. Currently, the interface code
uses PyGTK to present a GTK-based front end. As a similar Python
module for <a href="http://www.kde.org">KDE</a> exists, there is
no technical reason why the program could not have a native
KDE front end. Similarly, a <a href="http://www.gnome.org">GNOME</a>
front end could be created if the appropriate module is used. As Python
modules for other GUI environments appear, then ports to those
interfaces should be possible.  What will be needed are developers
willing to make these ports happen.
</p>
<p>
Building a program that would run under many different interfaces
would be a challenge. However, the difficulty is much less than
that faced by programs written in languages like C, as Python has
provided a common base on which to build. Having the code run
under KDE, GNOME, GTK, and whatever else would be a great way to
keep focused on designing a solid core program that does not rely
too heavily on one particular environment and its requirements.
Additionally, watching it run under various graphical interfaces
would be simply neat.
</p>
<h4>Future Development Directions</h4>
<p>
A page for listing some of the areas in which PythonCAD development
should address is <a href="checklist.html">here</a>. If you can think
of some features that PythonCAD should have, check the page and see
if they are there. If not, send a description of what you want to
have added.
</p>
<p>
PythonCAD has now been publicly available for two years. A short
<a href="summary2.html">summary</a> of the development efforts over
the second year is now available. The summary that appeared after
the first year of development is found <a href="status.html">here</a>.
</p>
<hr />
<h3>Links</h3>
<p>
Here are a few links to the things you need to run PythonCAD.
</p>
<ul>
<li><a href="http://www.python.org">Python</a></li>
<li><a href="http://www.gtk.org">GTK</a></li>
<li><a href="http://www.pygtk.org">PyGTK</a></li>
</ul>
<p>
PythonCAD <strong>does</strong> run on Windows if you have the Windows
ports of the required libraries and modules. The following links can
help you get the GTK and PyGTK libraries. Please note that there almost
certain to be issues with regards to file saving and loading on the
windows ports due to line-terminating differences. These will be worked
out eventually.
</p>
<ul>
<li><a href="http://www.pcpm.ucl.ac.be/~gustin/win32_ports/">PyGTK for Windows</a></li>
<li><a href="http://www.dropline.net/gtk/">GTK for Windows</a></li>
</ul>
<p>
Other sites may offer similar builds of these packages as well.
</p>
<p>
Here are a few links to some other good things ...
</p>
<ul>
<li><a href="http://www.debian.org">Debian</a></li>
<li><a href="http://www.xemacs.org">XEmacs</a></li>
<li><a href="http://www.gnu.org">GNU</a></li>
<li><a href="http://www.perl.org">Perl</a></li>
<li><a href="http://www.parrotcode.org">Parrot</a></li>
<li><a href="http://www.gnome.org">GNOME</a></li>
<li><a href="http://www.kde.org">KDE</a></li>
<li><a href="http://www.apache.org">Apache</a></li>
<li><a href="http://subversion.tigris.org">Subversion</a></li>
<li><a href="http://www.freebsd.org">FreeBSD</a></li>
<li><a href="http://www.dragonflybsd.org">DragonFlyBSD</a></li>
<li><a href="http://www.openbsd.org">OpenBSD</a></li>
<li><a href="http://www.netbsd.org">NetBSD</a></li>
</ul>
<hr />
<h3>E-mail the Developer</h3>
<dl>
<dt>
<strong>Just who is behind this?</strong>
</dt>
<dd>
My name is Art Haas. I started this project, and am currently the primary
developer. Care to join in the fun?
</dd>
<dt>
<strong>Can I reach you via e-mail?</strong>
</dt>
<dd>
Yes. Here is my e-mail address: <a href="mailto:ahaas@airmail.net">ahaas@airmail.net</a>.
Send me any patches you create, suggestions for improvements you
would like to see in PythonCAD, problem reports regarding PythonCAD, etc.
There is also a mailing list for PythonCAD. Visit the mailing list
<a href="http://mail.python.org/mailman/listinfo/pythoncad">homepage</a> 
for more info.
</dd>
</dl>
<hr />
</div><!-- main_content -->
<div id="footer">
<h3>Site Hosting Information</h3>
<div id="hwm">
The PythonCAD website is hosted by <a href="http://www.hwm-usa.com/">Hughes Web Marketing</a>.
</div><!-- hwm -->
<div id="w3c">
This page is <a href="http://validator.w3.org/check/referer">valid XHTML 1.0</a>.
</div><!-- w3c -->
</div><!-- footer -->
</body>
</html>
